MODE 2 ' 640 x 400 
page write 1 : cls
SPRITE LOAD "PLAYER.SPR", 1
CONST SCREEN_LEFT = 0
CONST SCREEN_RIGHT = 639
CONST SCREEN_TOP = 0
CONST SCREEN_BOTTOM = 399
CONST ACCEL = 1
CONST MOMENTUM = 0.95
x = SCREEN_RIGHT/2
y = SCREEN_BOTTOM/2
x_vel = 0
y_vel = 0
SPRITE SHOW 1, x , y , 1

DO
  KEYCHECK
  UPDATE_SPRITE
  WRAP_SPRITE
  SPRITE NEXT 1, x, y
  SPRITE MOVE
  DEBUG
  page copy 1,0,B
  PAUSE 1000/30
LOOP


SUB KEYCHECK
  for keycode = 128 to 131
    pressed = 0
    for key = 1 to 6
      if keydown(key) = keycode then pressed = 1
    next
    if keycode = 128 then u_pressed = pressed
    if keycode = 129 then d_pressed = pressed
    if keycode = 130 then l_pressed = pressed
    if keycode = 131 then r_pressed = pressed
  next
END SUB

SUB UPDATE_SPRITE
  if u_pressed then y_vel = y_vel - ACCEL
  if d_pressed then y_vel = y_vel + ACCEL
  if l_pressed then x_vel = x_vel - ACCEL
  if r_pressed then x_vel =  x_vel + ACCEL
  x = x + x_vel
  y = y + y_vel
  x_vel = x_vel * MOMENTUM
  y_vel = y_vel * MOMENTUM
END SUB

sub WRAP_SPRITE
  if x < SCREEN_LEFT then x = SCREEN_RIGHT-2
  if x > SCREEN_RIGHT then x = SCREEN_LEFT
  if y < SCREEN_TOP then y = SCREEN_BOTTOM-2
  if y > SCREEN_BOTTOM then y = SCREEN_TOP
END SUB

SUB DEBUG
  print @(10,10) "LOC: "  STR$(x,2 ,2)  "," STR$(y,2,2)
  print @(10,30) "VEL: "  STR$(x_vel,2, 2)  "," STR$(y_vel,2, 2)
END SUB